window.addEventListener("load", function() { formfiller.init(); }, false);

var formfiller = {
	
	//String Constants
	contextMenuID: "formfillerContextMenu",
	contextMenuItemPrefix: "formfillerMenuData",
	contextMenuOptionsID: "formfillerContextMenuOptions",
	stringBundle: "formfillerStrings",
 
 
  init: function() {
    //add formfiller as a preference observer to observe the preference extensions.formfiller.data
    var branch = formfillerData.branch ;
    branch.QueryInterface(Components.interfaces.nsIPrefBranch2);
    branch.addObserver("data", this, false); 
  	document.getElementById("contentAreaContextMenu").addEventListener("popupshowing", this.context, false);
  	this.buildMenu() ;
  },
  
  context: function() {
  	document.getElementById("formfillerContextMenu").hidden = !gContextMenu.onTextInput ;
  },

	observe: function(aSubject, aTopic, aData) {
		if(aTopic != "nsPref:changed") return ;
		this.buildMenu() ;
	},

	buildMenu: function() {
		var data = new Array() ;
		data = formfillerData.fillData() ;

  	var menu = document.getElementById(this.contextMenuID).firstChild ;
  	//empty menu
  	while(menu.hasChildNodes()) menu.removeChild(menu.firstChild) ;
  	//fill menu
  	for(var i=0; i < data.length; i++) {
  		var datum = data[i] ;
  		if(datum.value != "")
  		{
		  	var item = document.createElement("menuitem") ;
		  	item.setAttribute("id", this.contextMenuItemPrefix+datum.key) ;
		  	item.setAttribute("label", datum.value) ;
		  	item.setAttribute("class", "formfillerMenuData") ;
		  	item.setAttribute("oncommand", "formfiller.insertText(\""+datum.value+"\");") ;
		  	menu.appendChild(item) ;
  		}
    }
    if(menu.hasChildNodes()) {
    	menu.appendChild(document.createElement("menuseparator")) ;
    }
    var item = document.createElement("menuitem") ;
    item.setAttribute("id", "formfillerContextMenuOptions") ; 
    item.setAttribute("label", document.getElementById(this.stringBundle).getString("formfiller.contextmenuoptions")) ;
    item.setAttribute("oncommand", "window.openDialog('chrome://formfiller/content/options.xul', 'options', 'chrome');") ;
    menu.appendChild(item) ;
  },
  	  	
  
  
	insertText: function(aText) {
	  try {
	    var command = "cmd_insertText";
	    var controller = document.commandDispatcher.getControllerForCommand(command);
	    if (controller && controller.isCommandEnabled(command)) {
	      controller = controller.QueryInterface(Components.interfaces.nsICommandController);
	      var params = Components.classes["@mozilla.org/embedcomp/command-params;1"];
	      params = params.createInstance(Components.interfaces.nsICommandParams);
	      params.setStringValue("state_data", aText);
	      controller.doCommandWithParams(command, params);
	    }
	  }
	  catch (e) {
	    dump("Can't do cmd_insertText! ");
	    dump(e+"\n")
	  }
	}
}