var formfillerOptions = {
	dataListID: "formfillerOptionsDataList",
	dataItemPrefix: "formfillerDatum",
	addKeyID: "formfillerOptionsAddKeyName",
	addKeyValueID: "formfillerOptionsAddKeyValue",
	
	loadOptions: function() {
		var data = new Array() ;
		data = formfillerData.fillData() ;

  	var dl = document.getElementById(this.dataListID) ;

   	dl.setAttribute("rows", data.length) ;
  	for(var i=0; i < data.length; i++) {
  		var hbx = this.createOptionsRow(data[i].key, data[i].value) ;

  		dl.appendChild(hbx) ;
  	}
  },
  	
  createOptionsRow: function(key, value) {
  	var hbx = document.createElement("listitem") ;
  	hbx.setAttribute("key", key) ;
      
		var keyLbl = document.createElement("listcell") ;
		keyLbl.setAttribute("label", key + ":") ;
		hbx.appendChild(keyLbl) ;
		
		var txtbx = document.createElement("textbox") ;
		txtbx.setAttribute("id", this.dataItemPrefix + key) ;
		txtbx.setAttribute("class", "formfiller-list-textbox") ; 
		txtbx.setAttribute("value", value) ;
		hbx.appendChild(txtbx) ;
		
		return hbx ;
  },  	

  addKey: function() {
  	var keyName = document.getElementById(this.addKeyID) ;
  	if(keyName.value=="") {
  		alert("Please enter a key name!") ;
  		return ;
  	}
  	var data = formfillerData.fillData() ;
  	var keyValue = document.getElementById(this.addKeyValueID) ;
  	var dl = document.getElementById(this.dataListID) ;
  	dl.setAttribute("rows", parseInt(dl.getAttribute("rows"))+1) ;
  	var hbx = this.createOptionsRow(keyName.value, keyValue.value) ;
  	dl.appendChild(hbx) ;
  	keyName.value = "" ;
  	keyValue.value = "" ;
  	document.defaultView.sizeToContent() ;
  },
  	
  deleteKey: function() {
	  var list = document.getElementById(this.dataListID);
	  var count = list.selectedCount;
	  while (count--){
	    var item = list.selectedItems[0];
	    list.removeItemAt(list.getIndexOfItem(item));
	  }
	  list.setAttribute("rows", list.getRowCount()) ;
	  document.defaultView.sizeToContent() ;
	},
	
	moveUp: function() {
		var list = document.getElementById(this.dataListID) ;
		var count = list.selectedCount ;
		var selectedItems = new Array() ;
		//bubblesort list.selectedItems by the items index in the list
		for(var i = 0; i < count; i++) {
			for(var j = count-1; j  > i; j--) {
				if(list.getIndexOfItem(list.selectedItems[j]) < list.getIndexOfItem(list.selectedItems[j-1])) {
					var t = list.selectedItems[j] ;
					list.selectedItems[j] = list.selectedItems[j-1] ;
					list.selectedItems[j-1] = t ;
				}//if
			}//for j
		}//for i
		for(var i = 0; i < count; i++) {
			var item = list.selectedItems[0] ;
			var index = list.getIndexOfItem(item) ;
			if(index > 0)
			{
				list.insertBefore(item, list.getItemAtIndex(index-1));
			}
			selectedItems.push(item) ;
		}
		for(var i = 0; i < count; i++) {
			list.addItemToSelection(selectedItems[i]) ;
		}
	},

	moveDown: function() {
		var list = document.getElementById(this.dataListID) ;
		var count = list.selectedCount ;
		//reverse bubblesort list.selectedItems by the items index in the list
		//so that we move the last item down first.
		for(var i = 0; i < count; i++) {
			for(var j = count-1; j  > i; j--) {
				if(list.getIndexOfItem(list.selectedItems[j]) > list.getIndexOfItem(list.selectedItems[j-1])) {
					var t = list.selectedItems[j] ;
					list.selectedItems[j] = list.selectedItems[j-1] ;
					list.selectedItems[j-1] = t ;
				}//if
			}//for j
		}//for i
		for(var i = 0; i < count; i++) {
			var item = list.selectedItems[i] ;
			var index = list.getIndexOfItem(item) ;
			if(index < list.getRowCount()-1)
			{
				list.insertBefore(list.getItemAtIndex(index+1), item);
			}
		}
	},

  
  unload: function(aClose) {
		var cn = document.getElementById(this.dataListID).childNodes ;//array of <listitems>'s
  	var data = "" ;
  	var key = "" ;
  	var value = "" ;
  	for(var i=0; i<cn.length; i++)
  	{
  	 if(cn[i].nodeName != "listitem") {
  	 	continue ; 
  	 }
  	 key = cn[i].getAttribute("key") ;
  	 value = document.getElementById(this.dataItemPrefix+key).value ;
  	 data += escape(key) + formfillerData.delim + escape(value) ;
  	 
  	 if(i != cn.length-1) {
  	 	data += formfillerData.delim ;
  	 }
  	}
  	if(data != formfillerData.data) {
	  	formfillerData.setData(data) ;
  	}
  	if(aClose) {
  		window.close() ;
  	} else {
  	  document.getElementById("apply").setAttribute("disabled", "true") ;
  	}
  },  	
  
} ;
